diff --git a/sysdeps/unix/sysv/linux/alpha/lxstat.c b/sysdeps/unix/sysv/linux/alpha/lxstat.c
deleted file mode 100644
index eb03a5fbfe..0000000000
--- a/sysdeps/unix/sysv/linux/alpha/lxstat.c
+++ /dev/null
@@ -1,57 +0,0 @@
-/* lxstat using old-style Unix stat system call.
-   Copyright (C) 2004-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#define __lxstat64 __lxstat64_disable
-
-#include <errno.h>
-#include <stddef.h>
-#include <sys/stat.h>
-#include <kernel_stat.h>
-#include <sysdep.h>
-#include <sys/syscall.h>
-#include <xstatconv.h>
-
-#undef __lxstat64
-
-
-/* Get information about the file NAME in BUF.  */
-int
-__lxstat (int vers, const char *name, struct stat *buf)
-{
-  int result;
-  struct kernel_stat kbuf;
-
-  if (vers == _STAT_VER_KERNEL64)
-    {
-      result = INTERNAL_SYSCALL_CALL (lstat64, name, buf);
-      if (__glibc_likely (!INTERNAL_SYSCALL_ERROR_P (result)))
-	return result;
-      __set_errno (INTERNAL_SYSCALL_ERRNO (result));
-      return -1;
-    }
-
-  result = INTERNAL_SYSCALL_CALL (lstat, name, &kbuf);
-  if (__glibc_likely (!INTERNAL_SYSCALL_ERROR_P (result)))
-    return __xstat_conv (vers, &kbuf, buf);
-  __set_errno (INTERNAL_SYSCALL_ERRNO (result));
-  return -1;
-}
-hidden_def (__lxstat)
-weak_alias (__lxstat, _lxstat);
-strong_alias (__lxstat, __lxstat64);
-hidden_ver (__lxstat, __lxstat64)
diff --git a/sysdeps/unix/sysv/linux/generic/lxstat.c b/sysdeps/unix/sysv/linux/alpha/lxstat64.c
similarity index 55%
rename from sysdeps/unix/sysv/linux/generic/lxstat.c
rename to sysdeps/unix/sysv/linux/alpha/lxstat64.c
index 1cf082961a..90dc0c7ce7 100644
--- a/sysdeps/unix/sysv/linux/generic/lxstat.c
+++ b/sysdeps/unix/sysv/linux/alpha/lxstat64.c
@@ -1,6 +1,6 @@
-/* Copyright (C) 2011-2020 Free Software Foundation, Inc.
+/* lxstat using old-style Unix stat system call.
+   Copyright (C) 2004-2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
-   Contributed by Chris Metcalf <cmetcalf@tilera.com>, 2011.
 
    The GNU C Library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
@@ -16,33 +16,34 @@
    License along with the GNU C Library.  If not, see
    <https://www.gnu.org/licenses/>.  */
 
-/* Ignore prototype to avoid error if we alias __lxstat and __lxstat64. */
-#define __lxstat64 __lxstat64_disable
-
-#include <errno.h>
-#include <stddef.h>
-#include <fcntl.h>
+#define __lxstat __redirect___lxstat
 #include <sys/stat.h>
+#undef __lxstat
+#include <fcntl.h>
 #include <kernel_stat.h>
-
 #include <sysdep.h>
-#include <sys/syscall.h>
+#include <xstatconv.h>
 
 /* Get information about the file NAME in BUF.  */
 int
-__lxstat (int vers, const char *name, struct stat *buf)
+__lxstat64 (int vers, const char *name, struct stat64 *buf)
 {
-  if (vers == _STAT_VER_KERNEL)
-    return INLINE_SYSCALL (newfstatat, 4, AT_FDCWD, name, buf,
-                           AT_SYMLINK_NOFOLLOW);
-  errno = EINVAL;
-  return -1;
+  switch (vers)
+    {
+    case _STAT_VER_KERNEL64:
+      return INLINE_SYSCALL_CALL (lstat64, name, buf);
+
+    default:
+      {
+        struct kernel_stat kbuf;
+	int r = INTERNAL_SYSCALL_CALL (lstat, name, &kbuf);
+	if (r == 0)
+	  return __xstat_conv (vers, &kbuf, buf);
+	return INLINE_SYSCALL_ERROR_RETURN_VALUE (-r);
+      }
+    }
 }
+weak_alias (__lxstat64, __lxstat);
+weak_alias (__lxstat64, __GI___lxstat);
 
-hidden_def (__lxstat)
-weak_alias (__lxstat, _lxstat);
-#if XSTAT_IS_XSTAT64
-#undef __lxstat64
-strong_alias (__lxstat, __lxstat64);
-hidden_ver (__lxstat, __lxstat64)
-#endif
+hidden_def (__lxstat64)
diff --git a/sysdeps/unix/sysv/linux/arm/lxstat.c b/sysdeps/unix/sysv/linux/arm/lxstat.c
deleted file mode 100644
index 0efa0aea49..0000000000
--- a/sysdeps/unix/sysv/linux/arm/lxstat.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
diff --git a/sysdeps/unix/sysv/linux/generic/wordsize-32/lxstat.c b/sysdeps/unix/sysv/linux/generic/wordsize-32/lxstat.c
deleted file mode 100644
index bd02631d68..0000000000
--- a/sysdeps/unix/sysv/linux/generic/wordsize-32/lxstat.c
+++ /dev/null
@@ -1,55 +0,0 @@
-/* Copyright (C) 2011-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Chris Metcalf <cmetcalf@tilera.com>, 2011.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <stddef.h>
-#include <fcntl.h>
-#include <sys/stat.h>
-#include <kernel_stat.h>
-
-#include <sysdep.h>
-#include <sys/syscall.h>
-
-#if !XSTAT_IS_XSTAT64
-#include "overflow.h"
-#include <statx_cp.h>
-
-/* Get information about the file NAME in BUF.  */
-int
-__lxstat (int vers, const char *name, struct stat *buf)
-{
-  if (vers == _STAT_VER_KERNEL)
-    {
-#ifdef __NR_fstatat64
-      int rc = INLINE_SYSCALL (fstatat64, 4, AT_FDCWD, name, buf,
-                               AT_SYMLINK_NOFOLLOW);
-#else
-      struct statx tmp;
-      int rc = INLINE_SYSCALL (statx, 5, AT_FDCWD, name,
-                               AT_NO_AUTOMOUNT | AT_SYMLINK_NOFOLLOW,
-                               STATX_BASIC_STATS, &tmp);
-      if (rc == 0)
-        __cp_stat64_statx ((struct stat64 *)buf, &tmp);
-#endif
-      return rc ?: stat_overflow (buf);
-    }
-  errno = EINVAL;
-  return -1;
-}
-hidden_def (__lxstat)
-#endif
diff --git a/sysdeps/unix/sysv/linux/generic/wordsize-32/lxstat64.c b/sysdeps/unix/sysv/linux/generic/wordsize-32/lxstat64.c
deleted file mode 100644
index 3eab0a1847..0000000000
--- a/sysdeps/unix/sysv/linux/generic/wordsize-32/lxstat64.c
+++ /dev/null
@@ -1,66 +0,0 @@
-/* Copyright (C) 2011-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Chris Metcalf <cmetcalf@tilera.com>, 2011.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <https://www.gnu.org/licenses/>.  */
-
-/* Hide the prototype for __lxstat so that GCC will not complain about
-   the different function signature if it is aliased to  __lxstat64.
-   If XSTAT_IS_XSTAT64 is set to non-zero then the stat and stat64
-   structures have an identical layout but different type names.  */
-
-#define __lxstat __lxstat_disable
-
-#include <errno.h>
-#include <stddef.h>
-#include <fcntl.h>
-#include <sys/stat.h>
-#include <kernel_stat.h>
-
-#include <sysdep.h>
-#include <sys/syscall.h>
-
-#include <statx_cp.h>
-
-/* Get information about the file NAME in BUF.  */
-int
-__lxstat64 (int vers, const char *name, struct stat64 *buf)
-{
-  if (vers == _STAT_VER_KERNEL)
-    {
-#ifdef __NR_fstatat64
-      return INLINE_SYSCALL (fstatat64, 4, AT_FDCWD, name, buf,
-                             AT_SYMLINK_NOFOLLOW);
-#else
-      struct statx tmp;
-      int rc = INLINE_SYSCALL (statx, 5, AT_FDCWD, name,
-                               AT_NO_AUTOMOUNT | AT_SYMLINK_NOFOLLOW,
-                               STATX_BASIC_STATS, &tmp);
-      if (rc == 0)
-        __cp_stat64_statx (buf, &tmp);
-      return rc;
-#endif
-    }
-
-  errno = EINVAL;
-  return -1;
-}
-hidden_def (__lxstat64)
-
-#undef __lxstat
-#if XSTAT_IS_XSTAT64
-strong_alias (__lxstat64, __lxstat)
-hidden_ver (__lxstat64, __lxstat)
-#endif
diff --git a/sysdeps/unix/sysv/linux/hppa/lxstat.c b/sysdeps/unix/sysv/linux/hppa/lxstat.c
deleted file mode 100644
index 0efa0aea49..0000000000
--- a/sysdeps/unix/sysv/linux/hppa/lxstat.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
diff --git a/sysdeps/unix/sysv/linux/i386/lxstat.c b/sysdeps/unix/sysv/linux/i386/lxstat.c
deleted file mode 100644
index e960077893..0000000000
--- a/sysdeps/unix/sysv/linux/i386/lxstat.c
+++ /dev/null
@@ -1,60 +0,0 @@
-/* lxstat using old-style Unix lstat system call.
-   Copyright (C) 1991-2020 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-/* Ho hum, if xstat == xstat64 we must get rid of the prototype or gcc
-   will complain since they don't strictly match.  */
-#define __lxstat64 __lxstat64_disable
-
-#include <errno.h>
-#include <stddef.h>
-#include <sys/stat.h>
-#include <kernel_stat.h>
-
-#include <sysdep.h>
-#include <sys/syscall.h>
-
-#include <xstatconv.h>
-
-
-/* Get information about the file NAME in BUF.  */
-int
-__lxstat (int vers, const char *name, struct stat *buf)
-{
-  int result;
-
-  if (vers == _STAT_VER_KERNEL)
-    return INLINE_SYSCALL (lstat, 2, name, buf);
-
-  {
-    struct stat64 buf64;
-
-    result = INTERNAL_SYSCALL_CALL (lstat64, name, &buf64);
-    if (__glibc_unlikely (INTERNAL_SYSCALL_ERROR_P (result)))
-      return INLINE_SYSCALL_ERROR_RETURN_VALUE (INTERNAL_SYSCALL_ERRNO (result));
-    else
-      return __xstat32_conv (vers, &buf64, buf);
-  }
-}
-
-hidden_def (__lxstat)
-weak_alias (__lxstat, _lxstat);
-#if XSTAT_IS_XSTAT64
-#undef __lxstat64
-strong_alias (__lxstat, __lxstat64);
-hidden_ver (__lxstat, __lxstat64)
-#endif
diff --git a/sysdeps/unix/sysv/linux/lxstat.c b/sysdeps/unix/sysv/linux/lxstat.c
index dcd685873d..dc63d20061 100644
--- a/sysdeps/unix/sysv/linux/lxstat.c
+++ b/sysdeps/unix/sysv/linux/lxstat.c
@@ -1,4 +1,4 @@
-/* lxstat using old-style Unix lstat system call.
+/* lxstat using old-style Unix stat system call.
    Copyright (C) 1991-2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
@@ -16,45 +16,47 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-/* Ho hum, if xstat == xstat64 we must get rid of the prototype or gcc
-   will complain since they don't strictly match.  */
-#define __lxstat64 __lxstat64_disable
-
-#include <errno.h>
-#include <stddef.h>
 #include <sys/stat.h>
+#include <fcntl.h>
 #include <kernel_stat.h>
-
 #include <sysdep.h>
-#include <sys/syscall.h>
 
-#include <xstatconv.h>
+#if !XSTAT_IS_XSTAT64
+# include <xstatconv.h>
+# include <xstatover.h>
 
 /* Get information about the file NAME in BUF.  */
 int
 __lxstat (int vers, const char *name, struct stat *buf)
 {
-  if (vers == _STAT_VER_KERNEL)
-    return INLINE_SYSCALL (lstat, 2, name, buf);
-
-#if STAT_IS_KERNEL_STAT
-  return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
-#else
-  struct kernel_stat kbuf;
-  int result;
-
-  result = INLINE_SYSCALL (lstat, 2, name, &kbuf);
-  if (result == 0)
-    result = __xstat_conv (vers, &kbuf, buf);
-
-  return result;
+  switch (vers)
+    {
+    case _STAT_VER_KERNEL:
+      {
+# if STAT_IS_KERNEL_STAT
+	/* New kABIs which uses generic pre 64-bit time Linux ABI,
+	   e.g. csky, nios2  */
+	int r = INLINE_SYSCALL_CALL (fstatat64, AT_FDCWD, name, buf,
+				     AT_SYMLINK_NOFOLLOW);
+	return r ?: stat_overflow (buf);
+# else
+	/* Old kABIs with old non-LFS support, e.g. arm, i386, hppa, m68k,
+	   microblaze, s390, sh, powerpc, and sparc.  */
+	return INLINE_SYSCALL_CALL (lstat, name, buf);
+# endif
+      }
+
+    default:
+      {
+# if STAT_IS_KERNEL_STAT
+	return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
+# else
+	struct stat64 buf64;
+	int r = INTERNAL_SYSCALL_CALL (lstat64, name, &buf64);
+	return r ?: __xstat32_conv (vers, &buf64, buf);
 #endif
+      }
+    }
 }
-
 hidden_def (__lxstat)
-weak_alias (__lxstat, _lxstat);
-#if XSTAT_IS_XSTAT64
-#undef __lxstat64
-strong_alias (__lxstat, __lxstat64);
-hidden_ver (__lxstat, __lxstat64)
-#endif
+#endif /* XSTAT_IS_XSTAT64  */
diff --git a/sysdeps/unix/sysv/linux/lxstat64.c b/sysdeps/unix/sysv/linux/lxstat64.c
index 0ea8399d68..375013e9b1 100644
--- a/sysdeps/unix/sysv/linux/lxstat64.c
+++ b/sysdeps/unix/sysv/linux/lxstat64.c
@@ -1,5 +1,5 @@
 /* lxstat64 using Linux lstat64 system call.
-   Copyright (C) 1997-2020 Free Software Foundation, Inc.
+   Copyright (C) 1991-2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
    The GNU C Library is free software; you can redistribute it and/or
@@ -16,23 +16,65 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <errno.h>
-#include <stddef.h>
+#define __lxstat __redirect___lxstat
 #include <sys/stat.h>
+#undef __lxstat
+#include <fcntl.h>
 #include <kernel_stat.h>
-
 #include <sysdep.h>
-#include <sys/syscall.h>
+#include <xstatconv.h>
+#include <statx_cp.h>
 
 /* Get information about the file NAME in BUF.  */
+
 int
 ___lxstat64 (int vers, const char *name, struct stat64 *buf)
 {
-  int result;
-  result = INLINE_SYSCALL (lstat64, 2, name, buf);
-  return result;
+#if XSTAT_IS_XSTAT64
+# if defined __NR_lstat
+  /* Old 64-bit kABI, e.g. ia64, powerpc64*, s390x, sparc64, x86_64.  */
+  if (vers == _STAT_VER_KERNEL || vers == _STAT_VER_LINUX)
+    return INLINE_SYSCALL_CALL (lstat, name, buf);
+# elif defined __NR_newfstatat
+  /* New kABIs which uses generic 64-bit Linux ABI, e.g. aarch64, riscv64.  */
+  if (vers == _STAT_VER_KERNEL)
+    return INLINE_SYSCALL_CALL (newfstatat, AT_FDCWD, name, buf,
+				AT_SYMLINK_NOFOLLOW);
+# else
+  /* New 32-bit kABIs with only 64-bit time_t support, e.g. arc, riscv32.  */
+  if (vers == _STAT_VER_KERNEL)
+    {
+      struct statx tmp;
+      int r = INLINE_SYSCALL_CALL (statx, AT_FDCWD, name,
+				   AT_NO_AUTOMOUNT | AT_SYMLINK_NOFOLLOW,
+				   STATX_BASIC_STATS, &tmp);
+      if (r == 0)
+	__cp_stat64_statx (buf, &tmp);
+      return r;
+     }
+# endif
+#else
+# if STAT_IS_KERNEL_STAT
+  /* New kABIs which uses generic pre 64-bit time Linux ABI,
+     e.g. csky, nios2  */
+  if (vers == _STAT_VER_KERNEL)
+    return INLINE_SYSCALL_CALL (fstatat64, AT_FDCWD, name, buf,
+				AT_SYMLINK_NOFOLLOW);
+# else
+  /* Old kABIs with old non-LFS support, e.g. arm, i386, hppa, m68k,
+     microblaze, s390, sh, mips32, powerpc32, and sparc32.  */
+  return INLINE_SYSCALL_CALL (lstat64, name, buf);
+# endif /* STAT_IS_KERNEL_STAT  */
+#endif /* XSTAT_IS_XSTAT64  */
+
+  return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
 }
 
+#if XSTAT_IS_XSTAT64
+weak_alias (___lxstat64, __lxstat);
+weak_alias (___lxstat64, __GI___lxstat);
+#endif
+
 #include <shlib-compat.h>
 
 #if SHLIB_COMPAT(libc, GLIBC_2_1, GLIBC_2_2)
diff --git a/sysdeps/unix/sysv/linux/m68k/lxstat.c b/sysdeps/unix/sysv/linux/m68k/lxstat.c
deleted file mode 100644
index 0efa0aea49..0000000000
--- a/sysdeps/unix/sysv/linux/m68k/lxstat.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
diff --git a/sysdeps/unix/sysv/linux/microblaze/lxstat.c b/sysdeps/unix/sysv/linux/microblaze/lxstat.c
deleted file mode 100644
index 0efa0aea49..0000000000
--- a/sysdeps/unix/sysv/linux/microblaze/lxstat.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/lxstat.c b/sysdeps/unix/sysv/linux/mips/lxstat.c
similarity index 60%
rename from sysdeps/unix/sysv/linux/wordsize-64/lxstat.c
rename to sysdeps/unix/sysv/linux/mips/lxstat.c
index 156fbe7c64..eb07549adf 100644
--- a/sysdeps/unix/sysv/linux/wordsize-64/lxstat.c
+++ b/sysdeps/unix/sysv/linux/mips/lxstat.c
@@ -1,4 +1,4 @@
-/* lxstat using old-style Unix lstat system call.
+/* lxstat using old-style Unix stat system call.
    Copyright (C) 1991-2020 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
 
@@ -16,30 +16,27 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-/* Ho hum, since xstat == xstat64 we must get rid of the prototype or gcc
-   will complain since they don't strictly match.  */
-#define __lxstat64 __lxstat64_disable
-
-#include <errno.h>
-#include <stddef.h>
 #include <sys/stat.h>
-
+#include <fcntl.h>
+#include <kernel_stat.h>
 #include <sysdep.h>
-#include <sys/syscall.h>
+#include <xstatconv.h>
 
-/* Get information about the file FD in BUF.  */
+/* Get information about the file NAME in BUF.  */
 int
 __lxstat (int vers, const char *name, struct stat *buf)
 {
-  if (vers == _STAT_VER_KERNEL || vers == _STAT_VER_LINUX)
-    return INLINE_SYSCALL (lstat, 2, name, buf);
-
-  __set_errno (EINVAL);
-  return -1;
+  switch (vers)
+    {
+    case _STAT_VER_KERNEL:
+      return INLINE_SYSCALL_CALL (lstat, name, buf);
+
+    default:
+      {
+	struct kernel_stat kbuf;
+	int r = INTERNAL_SYSCALL_CALL (lstat, name, &kbuf);
+	return r ?: __xstat_conv (vers, &kbuf, buf);
+      }
+    }
 }
-
 hidden_def (__lxstat)
-weak_alias (__lxstat, _lxstat);
-#undef __lxstat64
-strong_alias (__lxstat, __lxstat64);
-hidden_ver (__lxstat, __lxstat64)
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/lxstat64.c b/sysdeps/unix/sysv/linux/mips/mips64/lxstat64.c
index 62d4fe70eb..28bac57e58 100644
--- a/sysdeps/unix/sysv/linux/mips/mips64/lxstat64.c
+++ b/sysdeps/unix/sysv/linux/mips/mips64/lxstat64.c
@@ -16,28 +16,18 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <errno.h>
-#include <stddef.h>
 #include <sys/stat.h>
 #include <kernel_stat.h>
-
 #include <sysdep.h>
-#include <sys/syscall.h>
-
 #include <xstatconv.h>
 
 /* Get information about the file NAME in BUF.  */
 int
 __lxstat64 (int vers, const char *name, struct stat64 *buf)
 {
-  int result;
   struct kernel_stat kbuf;
-
-  result = INLINE_SYSCALL (lstat, 2, name, &kbuf);
-  if (result == 0)
-    result = __xstat64_conv (vers, &kbuf, buf);
-
-  return result;
+  int r = INLINE_SYSCALL_CALL (lstat, name, &kbuf);
+  return r ?: __xstat64_conv (vers, &kbuf, buf);
 }
 
 hidden_def (__lxstat64)
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc32/lxstat.c b/sysdeps/unix/sysv/linux/powerpc/powerpc32/lxstat.c
deleted file mode 100644
index 2371cd9719..0000000000
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc32/lxstat.c
+++ /dev/null
@@ -1,2 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
-
diff --git a/sysdeps/unix/sysv/linux/s390/s390-32/lxstat.c b/sysdeps/unix/sysv/linux/s390/s390-32/lxstat.c
deleted file mode 100644
index 0efa0aea49..0000000000
--- a/sysdeps/unix/sysv/linux/s390/s390-32/lxstat.c
+++ /dev/null
@@ -1 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
diff --git a/sysdeps/unix/sysv/linux/sh/lxstat.c b/sysdeps/unix/sysv/linux/sh/lxstat.c
deleted file mode 100644
index 2371cd9719..0000000000
--- a/sysdeps/unix/sysv/linux/sh/lxstat.c
+++ /dev/null
@@ -1,2 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
-
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc32/lxstat.c b/sysdeps/unix/sysv/linux/sparc/sparc32/lxstat.c
deleted file mode 100644
index 2371cd9719..0000000000
--- a/sysdeps/unix/sysv/linux/sparc/sparc32/lxstat.c
+++ /dev/null
@@ -1,2 +0,0 @@
-#include <sysdeps/unix/sysv/linux/i386/lxstat.c>
-
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc64/lxstat.c b/sysdeps/unix/sysv/linux/sparc/sparc64/lxstat.c
deleted file mode 100644
index 7f1e98e433..0000000000
--- a/sysdeps/unix/sysv/linux/sparc/sparc64/lxstat.c
+++ /dev/null
@@ -1 +0,0 @@
-#include "../../i386/lxstat.c"
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/lxstat64.c b/sysdeps/unix/sysv/linux/wordsize-64/lxstat64.c
deleted file mode 100644
index bb5dbd0fff..0000000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/lxstat64.c
+++ /dev/null
@@ -1 +0,0 @@
-/* lxstat64 is in lxstat.c */